Subject: Re: [ippm] Discussion on draft-brockners-ippm-ioam-data-integrity method 3 variant in @ietf110

From: Shwetha <[email-masked]>
Date: Wed, 7 Jul 2021 12:47:45 +0530

Hi All,

A new version of the IOAM data integrity has been posted :
https://datatracker.ietf.org/doc/html/draft-brockners-ippm-ioam-data-integrity-02

This addresses the feedback and discussion during IETF 110 and in this
email thread:
1. Recommends one method for carrying data integrity for IOAM options.
Other methods discussed are moved to Appendix.
2. Introduces asymmetric key based signing variant to it.
3. Adds IOAM data integrity option format and IANA considerations.
4. Updates overhead considerations to include sampling.

Looking forward to continued discussion on this here and at the upcoming
IPPM wg meeting.

Thanks,
Shwetha

On Sun, Mar 28, 2021 at 3:52 PM Frank Brockners (fbrockne) <
[email-masked]> wrote:

> Hi Al,
>
>
>
> Thanks much – and I fully agree that we need to keep the deployment and
> associated cost aspects in mind when designing a solution for IOAM
> data-fields integrity.  We should also acknowledge that while integrity
> protection might be considered important for some future deployment,
> current uses of early implementations of IOAM or similar are in “limited
> and isolated domains” and they do well without an integrity protection
> solution. So we’re talking about a “niche” for now, though one which might
> become more important in the future if IOAM would get applied to “not so
> trusted environments”.  We can expect integrity protection to add a
> non-negligible burden on a deployment – hence we need to come up with a
> solution that is modular enough, so that operators and implementors can
> choose how they cut the balance between “protection” and “cost”.
>
>
>
> The ”Performance and Diagnostic Metrics (PDM) team” (Michael, Nalini)
> already reached out – with the plan to investigate whether we can’t create
> a single solution which would cover PDM and IOAM – something that everyone
> would for sure appreciate.
>
>
>
> Per your (great!) suggestion, I’m cc’ing Ben for any help / pointers to
> additional folks who might be interested in helping us design an adequate
> solution.
>
>
>
> Thanks, Frank
>
>
>
> *From:* MORTON, ALFRED C (AL) <[email-masked]>
> *Sent:* Samstag, 27. März 2021 18:38
> *To:* Frank Brockners (fbrockne) <[email-masked]>; Tommy Pauly <
> [email-masked]>; Tommy Pauly <[email-masked]>; Shwetha <
> [email-masked]>
> *Cc:* IETF IPPM WG ([email-masked]) <[email-masked]>
> *Subject:* RE: [ippm] Discussion on
> draft-brockners-ippm-ioam-data-integrity method 3 variant in @ietf110
>
>
>
> Hi Frank, Tommy, and all,
>
>
>
> TL;DR: No solution, just trying to refine the problem statement and
> suggestion to seek SEC advice.
>
>
>
> I haven’t followed the integrity discussions closely, but hearing the
> review of options at the IETF-110/IPPM session, and additional details for
> the options that Frank described below, it seems we could use some expert
> advice. There is a perpetual tension between protection from various
> attacks and the protocol performance achievable in practice, especially
> when considering per-packet integrity. IOW, if the security measures drag
> down too hard on performance, they won’t be used in practice.
>
>
>
> In a successful end-game, we will have balanced the (possibly increased)
> risks inherent in the selected security measures with the practical
> per-packet implementation (requiring high packet-per-second rates, wide
> distribution, and other deployment needs).
>
>
>
> I’m a very interested spectator here, because we may need to solve this
> problem again for packet streams used in high-capacity testing with
> widespread deployment.
>
>
>
> So, advice in the form of a recommended solution to our particular problem
> with an acceptable level of risk, from SEC-Dir, SEC-ADs, or elsewhere,
> might help us winnow-down the choices.
>
>
>
> hope this helps,
>
> Al
>
>
>
>
>
> *From:* ippm [mailto:[email-masked] <[email-masked]>] *On
> Behalf Of *Frank Brockners (fbrockne)
> *Sent:* Saturday, March 27, 2021 10:54 AM
> *To:* Tommy Pauly <[email-masked]>; Tommy Pauly <
> tpauly=[email-masked]>; Shwetha <[email-masked]>
> *Cc:* IETF IPPM WG ([email-masked]) <[email-masked]>
> *Subject:* Re: [ippm] Discussion on
> draft-brockners-ippm-ioam-data-integrity method 3 variant in @ietf110
>
>
>
> Hi Tommy, IPPM WG,
>
>
>
> We’ll look into the update after the Easter break. Before that, I’d
> greatly appreciate further input and thoughts on the preferred methods.
>
>
>
> In our IPPM WG meeting during IETF 110, you voiced a preference for Method
> 3 – broken up into a “Method 3a – with symmetric key (the current Method
> 3)” and a “Method 3b – with asymmetric keys”.
>
>
>
> Per the discussion, the Method 3 approach suffers from the challenges that
> one would need to provision a secret per packet, which is a significant
> effort – but provides for replay protection. Detecting whether a secret has
> already been used or not is detectable by the verifier. Method 4 also
> provides for replay protection given that it also uses a secret per packet
> and at the same time is to help the secret provisioning issue, given that
> we’d only bootstrap a key generator on the nodes and would then leverage
> Key-IDs – which makes “secrets per packet” much more manageable.
>
>
>
> Per the note above, during the WG discussion, a preference was voiced for
> “Method 3” – but at the same time, asked for avoiding a secret per packet –
> but re-using the secret for multiple packets, e.g. defined by duration or
> number of packets. How would we arrive at a solution for replay
> protection in that case?
>
> Options we could consider include:
> (a) Include the payload (or portions of the payload) into the signing
> process, so that the signed IOAM data becomes unique and cannot be easily
> re-used for future packets.
>
> (b) Include an additional “identifier” or “nonce” as part of the
> IOAM-data, which would make the IOAM-data and thus the signature unique –
> which could be checked and tracked by the verifiers.
>
> (c) ? any other options ?
>
>
>
> Thoughts? Opinions? Preferences?
>
>
>
> While evolving the design for Method3 (or better 3a and 3b), I’d suggest
> that we keep Method 4 on the table for now.
>
>
>
> Thanks, Frank
>
>
>
> *From:* Tommy Pauly <[email-masked]>
> *Sent:* Freitag, 26. März 2021 21:58
> *To:* Tommy Pauly <tpauly=[email-masked]>; Shwetha <
> [email-masked]>; Frank Brockners (fbrockne) <
> [email-masked]>
> *Cc:* IETF IPPM WG ([email-masked]) <[email-masked]>
> *Subject:* Re: [ippm] Discussion on
> draft-brockners-ippm-ioam-data-integrity method 3 variant in @ietf110
>
>
>
> Just checking here—when could we expect an updated proposal for the
> integrity document? Once we can converge on a set of approaches we like, we
> would like to get this prepared for a WG adoption.
>
>
>
> Best,
>
> Tommy
>
>
>
> On Mar 12, 2021, at 6:30 AM, Tommy Pauly <
> tpauly=[email-masked]> wrote:
>
>
>
> Thanks, that’d be great to see the variants of Method 3 like that!
>
>
>
> Best,
>
> Tommy
>
>
>
> On Mar 8, 2021, at 8:31 PM, Shwetha <[email-masked]> wrote:
>
>
>
> My bad, it should be possible to reverse the process for validation and
> retrieve the previous signature in the reverse order. We will update the
> draft to have Method 3 with both symmetric/asymmetric variants.
>
>
>
> Thanks,
>
> Shwetha
>
>
>
> On Tue, Mar 9, 2021 at 7:07 AM Shwetha <[email-masked]> wrote:
>
> During the session 1 of ippm at IETF 110, it was suggested to consider
> introducing a variant of method 3
> in  draft-brockners-ippm-ioam-data-integrity with asymmetric keys.
>
>
>
>
>
> When we were designing the methods to protect integrity of the entire IOAM
> data collected at each node, the node chains it's own node data with the
> signature from the previous node and overwrites the signature:
>
> Trace signature = sign([Trace Signature || its node_data_list[x] hash])
>
>
>
> In the symmetric key case this operation can be validated by reversing the
> operation by the validator who has the shared secret from each node.
>
> However this will not work if nodes use their private keys to sign and
> validator has the public key to validate as it can only validate but not
> derive a specific node's signature to reverse the operation.
>
>
>
> So I think the space optimized  method to overwrite the signature at each
> node cannot be modified to use asymmetric keys easily. Will be happy to
> discuss ideas to create a space optimized asymmetric key based solution.
>
>
>
> Thanks
>
> Shwetha
>
>
>
> _______________________________________________
> ippm mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ippm
> <https://urldefense.com/v3/__https:/www.ietf.org/mailman/listinfo/ippm__;!!BhdT!04mWk9x-Ut5K0ecNHfnt8g_vEeQPXwZx8oP_51cSZNUP214MyjqOchkEeA3R$>
>
>
>
> _______________________________________________
> ippm mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ippm
> <https://urldefense.com/v3/__https:/www.ietf.org/mailman/listinfo/ippm__;!!BhdT!04mWk9x-Ut5K0ecNHfnt8g_vEeQPXwZx8oP_51cSZNUP214MyjqOchkEeA3R$>
>
>
>